import rox
from rox import g, OptionsBox
from rox.options import Option
from rcfile import Opt, OptionGroupRC, update_options

### TODO:
###
### A special widget for button layout? (drag and drop of symbols)
###

app_name = 'OroboROX'

def build_mytoggle(box, node, label, option):
	toggle = g.CheckButton(label)
	box.may_add_tip(toggle, node)
	def get():
		if toggle.get_active():
			return 'true'
		else:
			return 'false'
	def set():
		if option.value == 'true':
			toggle.set_active(True)
		else:
			toggle.set_active(False)
		
	box.handlers[option] = (get, set)
	toggle.connect('toggled', lambda w: box.check_widget(option))
	return [toggle]

def build_buttonfilter(box, node, label, option):
	vbox = g.VBox()
	l=g.Label('')
	l.set_markup('<b>'+label+'</b>')
	l.set_padding(0,4)
	vbox.add(l)
	vbox.set_border_width(8)
	
	toggles = {}
	for (char, label) in [
		('T',_('Sticky')),
		('S',_('Shade')),
		('H',_('Hide')),
		('M',_('Maximize')),
		('C',_('Close'))
		]:
		t = g.CheckButton(label)
		toggles[char]=t
		vbox.add(t)
		t.connect('toggled', lambda w: box.check_widget(option))
#		box.tips.set_tip(t,
#'Enable / disable the %s button on the titlebar.' % (label))

	def get():
		s = ''
		for (char,t) in toggles.iteritems():
			if not t.get_active(): s += char
		return s
		
	def set():
		for t in toggles.values(): t.set_active(True)
		for char in option.value: toggles[char].set_active(False)
		
	box.handlers[option] = (get, set)
	return [vbox]

#OptionsBox.widget_registry['keybutt'] = build_keybutt
OptionsBox.widget_registry['mytoggle'] = build_mytoggle
OptionsBox.widget_registry['buttonfilter'] = build_buttonfilter

rox.app_options = OptionGroupRC(app_name,'windowrc')

Option('title_alignment',' ') #NOTE: the space is needed...
Option('button_layout','')
Option('button_filter','')
Option('dialog_skip_buttons','')
Option('borderless_windows','')
Option('sticky_windows','')
Option('iconic_windows','')
Option('ontop_windows','')

Opt('buttons_show_state')
Opt('font')
Opt('focus_policy')
Opt('switch_to_active_win')
Opt('double_click_action')
Opt('box_move')
Opt('box_resize')
Opt('focus_new')
Opt('raise_delay')
Opt('window_placement')
Opt('snap_to_border')
Opt('snap_to_windows')
Opt('snap_width')
Opt('warp_mouse')
Opt('border_drag')
Opt('button2_frame_click')
Opt('button3_frame_click')
Opt('button2_frame_drag')
Opt('button3_frame_drag')

#Opt('hide_window_key')
#Opt('close_window_key')
#Opt('toggle_fullscreen_window_key')
#Opt('maximize_window_key')
#Opt('shade_window_key')
#Opt('cycle_windows_key')
#Opt('raise_window_layer_key')
#Opt('lower_window_layer_key')
#Opt('move_window_up_key')
#Opt('move_window_down_key')
#Opt('move_window_left_key')
#Opt('move_window_right_key')
#Opt('stick_window_key')
#Opt('maximize_vert_key')
#Opt('maximize_horiz_key')
#Opt('resize_window_up_key')
#Opt('resize_window_down_key')
#Opt('resize_window_left_key')
#Opt('resize_window_right_key')
#Opt('move_top_left_key')
#Opt('move_top_right_key')
#Opt('move_bottom_left_key')
#Opt('move_bottom_right_key')
#Opt('window_ops_modifiers')
#Opt('toggle_fullscreen_window_all_key')
#Opt('maximize_window_all_key')
#Opt('maximize_vert_all_key')
#Opt('maximize_horiz_all_key')
#Opt('toggle_borders_key')

rox.app_options.add_notify(update_options)
rox.app_options.notify()
rox.edit_options()
